#! /bin/bash
### BEGIN INIT INFO
# Provides:          qhwebsec
# Required-Start:    
# Should-Start: $ALL
# Required-Stop:    
# Default-Start:     2 3 4 5
# Default-Stop:      S 0 1 6
# Short-Description: web security deamon
# Description:       Start and stop the web security deamon.
### END INIT INFO

#
# Revision History:
# Date:   June 30 2014.
# Author: Prashant SB.
# Desc:   Created.
#

# Do NOT "set -e"
PRODUCT_NAME="Seqrite"
QHEPSDIR="/usr/lib/${PRODUCT_NAME}/${PRODUCT_NAME}"
QHAVDIR="/usr/lib/${PRODUCT_NAME}"

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/usr/sbin:/usr/bin:/sbin:/bin
DESC="${PRODUCT_NAME} Web Security "
#URL_DAEMON_DESC="Commtouch URL Categorization Server"

if [ -f ${QHEPSDIR}/QHfunctions ]; then
        . ${QHEPSDIR}/QHfunctions
        QHINSDIR=${QHEPSDIR}
else
        if [ -f ${QHAVDIR}/QHfunctions ]; then
                . ${QHAVDIR}/QHfunctions
                QHINSDIR=${QHAVDIR}
        fi
fi

#CONFIG_FILEPATH=$QHINSDIR/"websec.cfg"
#CATENGINE_STRING="catEngine"
#CAT_ENGINE_FLAG=`grep $CATENGINE_STRING $CONFIG_FILEPATH | cut -d '=' -f2`
#USE_URLCAT='1'

#CATENGINE_BINNAME="ctwsd"
#CATENGINE_BINNAME="ctwsd.bin"
#QH_CTWSD_DIRNAME="ctwsd"
#COMMTOUCH_CONFIG_FILE="ctwsd.conf"
#DAEMON_CONFIG_FILE_PATH="$QHINSDIR/$QH_CTWSD_DIRNAME/$COMMTOUCH_CONFIG_FILE"
#CATENGINE_BINARY_PATH=$QHINSDIR/$QH_CTWSD_DIRNAME/$CATENGINE_BINNAME
#CATENGINE_BINARY_PATH_ARGS="-- -c $DAEMON_CONFIG_FILE_PATH"
#QHSHDL_PIDFILE=/var/run/$CATENGINE_BINNAME.pid

NAME="websecd"
DAEMON="$QHINSDIR/$NAME"
DAEMON_ARGS="" #--options args"
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/qhwebsec

#if [ $CAT_ENGINE_FLAG -eq $USE_URLCAT ]; then
#	#CATENGINE_BINNAME="urlcatd"
#	CATENGINE_BINNAME="urlcatd"
#	CATENGINE_BINARY_PATH="$QHINSDIR/$CATENGINE_BINNAME"
#    QHSHDL_PIDFILE=/var/run/$CATENGINE_BINNAME.pid
#	URL_DAEMON_DESC="${PRODUCT_NAME} URL Categorization Server"
#fi


# Check root user.
if [ $(id -u) -ne 0 ]
then
        if [ "$1" != "start" -a "$1" != "stop" -a "$1" != "restart" -a "$1" != "force-reload" -a "$1" != "status" ];
        then
                echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload|status}" >&2
                exit 0
        fi

        if [ "$1" != "status" ]
        then
                echo "You are not root user. Please login as root user.";
                exit 0
        fi
fi


# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0
#if [ $CAT_ENGINE_FLAG -eq $USE_URLCAT ]; then
#	[ -x "$CATENGINE_BINARY_PATH" ] || exit 0

#fi

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
[ -f /etc/default/rcS ] && . /etc/default/rcS

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

PATH="/bin:/usr/bin:/usr/local/bin:/sbin:/usr/sbin:/usr/local/sbin"

#
# Function that starts the daemon/service
#
#start_URLCAT()
#{
#	COUNT=0
#	for PROC in $(ps axw -o "pid= command=" | grep ${CATENGINE_BINNAME} | grep -v grep)
#	do
#		if [ "${PROC%%[!0123456789]*}" = "${PROC}" ]
#		then
#			COUNT=$((${COUNT} + 1))
#		fi
#	done
#	if [ ${COUNT} -ge 1 ]
#	then
#		echo "$URL_DAEMON_DESC $CATENGINE_BINNAME is already running..."
#		return 0
#	fi
#
#	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $URL_DAEMON_DESC" "$CATENGINE_BINNAME"
#	do_start_URLCAT
#	case "$?" in
#		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
#		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
#	esac
#
#}

start_WEBSEC()
{

	# Check if already runnning;
	COUNT=0
	for PROC in $(ps axw -o "pid= command=" | grep ${NAME} | grep -v grep)
	do
		if [ "${PROC%%[!0123456789]*}" = "${PROC}" ]
		then
			COUNT=$((${COUNT} + 1))
		fi
	done
	if [ ${COUNT} -ge 1 ]
	then
		echo "$DESC $NAME is already running..."
		exit 1
	fi

	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
	do_start_WEBSEC
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
}

do_start()
{
	
	#if [ $CAT_ENGINE_FLAG -eq $USE_URLCAT ]; then
	#	start_URLCAT
	#fi
	start_WEBSEC
	
}

#do_start_URLCAT()
#{
#	start-stop-daemon --quiet --make-pidfile --pidfile $QHSHDL_PIDFILE --exec $CATENGINE_BINARY_PATH --start  || return 1
#
#	sleep 1
#}

do_start_WEBSEC()
{

	start-stop-daemon --quiet --make-pidfile --pidfile $PIDFILE --exec $DAEMON --start \
		|| return 1

	sleep 1
}


#
# Function that stops the daemon/service
#
do_stop()
{
	# Return
	#   0 if daemon has been stopped
	#   1 if daemon was already stopped
	#   2 if daemon could not be stopped
	#   other if a failure occurred

	#Websec stop


	#if [ $CAT_ENGINE_FLAG -eq $USE_URLCAT ]; then
	#	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping "$URL_DAEMON_DESC" $CATENGINE_BINNAME" 
	#	do_stop_URLCAT
	#	case "$?" in
	#		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
	#		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	#	esac
	#fi

	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
	do_stop_WEBSEC
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
	
}

#do_stop_URLCAT()
#{
#	#Category server stop
#
#	start-stop-daemon --quiet --name $CATENGINE_BINNAME --retry TERM/30/KILL/5 --stop
#	RETVAL="$?"
#	[ "$RETVAL" = 2 ] && return 2
#	# Wait for children to finish too if this is a daemon that forks
#	# and if the daemon is only ever run from this initscript.
#	# If the above conditions are not satisfied then add some other code
#	# that waits for the process to drop all resources that could be
#	# needed by services started subsequently.  A last resort is to
#	# sleep for some time.
#	start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $CATENGINE_BINARY_PATH
#	[ "$?" = 2 ] && return 2
#	# Many daemons don't delete their pidfiles when they exit.
#	rm -f $QHSHDL_PIDFILE
#
#}

do_stop_WEBSEC()
{

	start-stop-daemon --quiet --name $NAME --retry TERM/30/KILL/5 --stop
	RETVAL="$?"
	[ "$RETVAL" = 2 ] && return 2
	# Wait for children to finish too if this is a daemon that forks
	# and if the daemon is only ever run from this initscript.
	# If the above conditions are not satisfied then add some other code
	# that waits for the process to drop all resources that could be
	# needed by services started subsequently.  A last resort is to
	# sleep for some time.
	start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
	[ "$?" = 2 ] && return 2
	# Many daemons don't delete their pidfiles when they exit.
	rm -f $PIDFILE

	return "$RETVAL"

}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
	#
	# If the daemon can reload its configuration without
	# restarting (for example, when it is sent a SIGHUP),
	# then implement that here.
	#
	#if [ $CAT_ENGINE_FLAG -eq $USE_URLCAT ]; then
	#	start-stop-daemon --stop --signal 1 --quiet --pidfile $QHSHDL_PIDFILE --name $CATENGINE_BINNAME
	#fi
	
	start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
	
	return 0
}


#status_URLCAT()
#{
#
#	COUNT=0
#	for PROC in $(ps axw -o "pid= command=" | grep ${CATENGINE_BINNAME} | grep -v grep)
#	do
#		if [ "${PROC%%[!0123456789]*}" = "${PROC}" ]
#		then
#			COUNT=$((${COUNT} + 1))
#		fi
#	done
#	if [ ${COUNT} -ge 1 ]
#	then
#		echo "$URL_DAEMON_DESC $CATENGINE_BINNAME is running..."
#	else
#		echo "$URL_DAEMON_DESC $CATENGINE_BINNAME is stopped..."
#	fi
#
#}

status_WEBSEC()
{

	COUNT=0
	for PROC in $(ps axw -o "pid= command=" | grep ${NAME} | grep -v grep)
	do
		if [ "${PROC%%[!0123456789]*}" = "${PROC}" ]
		then
			COUNT=$((${COUNT} + 1))
		fi
	done
	if [ ${COUNT} -ge 1 ]
	then
		echo "$DESC $NAME is running..."
	else
		echo "$DESC $NAME is stopped..."
	fi

}

case "$1" in
  start)

	# Start URL categorization server
	do_start

	;;
  stop)
	
	do_stop
	;;
  #reload|force-reload)
	#
	# If do_reload() is not implemented then leave this commented out
	# and leave 'force-reload' as an alias for 'restart'.
	#
	#log_daemon_msg "Reloading $DESC" "$NAME"
	#do_reload
	#log_end_msg $?
	#;;
  restart|force-reload)
	#
	# If the "reload" option is implemented then remove the
	# 'force-reload' alias
	#
	#log_daemon_msg "Restarting $DESC" "$NAME"
	do_stop
	case "$?" in
	  0|1)
		do_start
		#case "$?" in
		#	0) log_end_msg 0 ;;
		#	1) log_end_msg 1 ;; # Old process is still running
		#	*) log_end_msg 1 ;; # Failed to start
		#esac
		;;
	  *)
	  	# Failed to stop
		log_end_msg 1
		;;
	esac
	;;

  status)
	# Check status;
	
	#if [ $CAT_ENGINE_FLAG -eq $USE_URLCAT ]; then
	#	status_URLCAT
	#fi
	status_WEBSEC

	;;

  *)
	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
	echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload|status}" >&2
	exit 3
	;;
esac

:
